## mah-jong 1.4

=== Makefile ===
# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.9 2002/01/07 21:45:29 jcb Rel $
# Master makefile for the xmj suite.

### NOTE NOTE NOTE
### This makefile uses some features specific to GNU make.
### If you do not have GNU make, you will need to adjust it.
### In particular, example Windows specific settings are included here
### by means of    ifdef Win32   conditionals (where Win32 is a Makefile
### variable that can be set on the command line, for example).
### It should be easy to edit these out.
### As far as I know, the only other non-portable feature is the
### use of %-pattern rules, but they occur in many makes.

# The things you are most likely to change come first!

# first target: don't change!
all::

### Local configuration options. Read and edit as necessary.

# The directory in which to find the tile pixmaps that are
# compiled into the program. Beware of licensing considerations.
# (The tiles-v1 pixmaps may only be linked into GPLed programs.)
FALLBACKTILES=./tiles-v1

# The directory in which to find tile pixmaps.
# Defaults to NULL, causing the compiled-in tiles to be used.
TILESET=NULL

# The search path for finding tile pixmap directories.
# Defaults to NULL, meaning current directory.
TILESETPATH=NULL

# Where to install the programs.
# (Don't bother with this on Windows; I don't have an install target
# for Windows.)
# The binaries go into  $(DESTDIR)$(BINDIR)
DESTDIR = /usr/local/
BINDIR = bin
# The man pages go into $(DESTDIR)$(MANDIR)
MANDIR = man/man1
# and the appropriate suffix is 1
MANSUFFIX = 1

### End of local configuration.

### System dependent settings.
# This section contains compiler settings etc.
# If you think this reminds of you something, you're right: this
# makefile was made by stripping out most of an imake-generated file.

# It's best to use gcc if you can.
CC = gcc

# C debugging and optimization flags. 
# In development, we turn on all reasonable warnings, thus:
# CDEBUGFLAGS = -g -Wall -W -Wstrict-prototypes -Wmissing-prototypes
# However, in the production releases, we don't because other people's
# code (e.g. glib) may provoke warnings.
# Also, we do NOT enable optimization by default, because RedHat 6
# Linux distributions have a seriously buggy C compiler.
CDEBUGFLAGS = -g
# The -Wconversion flag is also useful to detect (more than usual)
# abuse of enums, but it generates many superfluous warnings, so
# is not on by default.
# To check for non-ANSI usages, use -ansi; 
# to get all the ANSI-mandated warnings, use -pedantic, but 
# this is so pedantic it's not worth it.

# Defines for the compilation.
ifdef Win32
# This doesn't work if one tries to set these. Does anybody know
# how to get a double quote through DOS or whatever to gcc ?
DEFINES = -DTILESET=$(TILESET) -DTILESETPATH=$(TILESETPATH) -DWIN32=1
else
DEFINES = -DTILESET='$(TILESET)' -DTILESETPATH='$(TILESETPATH)'
endif

# Options for compiling.
ifdef Win32
# I assume you're using mingw. If you're using cygwin, you also
# need -fno-cygwin.
CCOPTIONS = -fnative-struct
endif

# Extra libraries needed above whatever the system provides you with.
# Things like -lnsl on Solaris are the most likely examples.
ifdef Win32
# We need the winsock libraries
LDLIBS = -LC:/winnt/system32 -lwsock32
else
# Red Hat and Mandrake (and probably most other) Linux systems
# need nothing, as any needed libraries are brought in for gtk anyway.
LDLIBS =
# If you are on Solaris, you may need the following:
# LDLIBS = -lsocket -lnsl
# If you are on HP-UX, you may need
# LDLIBS = -lm
endif

# The xmj program is built with gtk+, so it needs to know where the
# libraries and headers are.
ifdef Win32
# You'll need to say explicitly where they are, as here:
EXTRA_INCLUDES=-IC:/gtk/glib -IC:/gtk
# We also add the flag that makes xmj.exe be a GUI program
GUILIBS=-LC:/gtk -lgtk-1.3 -lgdk-1.3 -lglib-1.3 -lgmodule-1.3 -Wl,-subsystem,windows
else
# Not Windows. If gtk+ is properly installed, this is all that's needed.
EXTRA_INCLUDES=`gtk-config --cflags`
GUILIBS=`gtk-config --libs`
endif

# We use gcc to link as well
CCLINK = $(CC)

# don't mess with these
ALLINCLUDES = $(INCLUDES) $(EXTRA_INCLUDES)
ALLDEFINES = $(ALLINCLUDES) $(EXTRA_DEFINES) $(DEFINES)
CFLAGS = $(EXTRA_CFLAGS) $(CDEBUGFLAGS) $(CCOPTIONS) $(ALLDEFINES)
LDOPTIONS = $(CDEBUGFLAGS) $(CCOPTIONS)  $(EXTRA_LDOPTIONS)

# various auxiliary program and settings.
ifndef Win32
# GNU make, we hope
MAKE = make
CP = cp -f
RM = rm -f
# makedep is a gcc-based makedepend that doesn't look at the 
# standard files.
DEPEND = ./makedep
DEPENDFLAGS =
# perl is needed for generating several files
PERL = perl
# suffix of executables
EXE = 
# programs used in installation
MKDIRHIER = mkdir -p
INSTALL = install
INSTALLFLAGS = -c
INSTPGMFLAGS = -s
INSTMANFLAGS = -m 0444
else
# Windows
# GNU make, we hope
MAKE = make
CP = xcopy
RM = rm /f
# we don't have a makedepend on windows ...
DEPEND =
DEPENDFLAGS =
# perl is needed for generating several files
PERL = perl
# suffix of executables
EXE = .exe
# programs used in installation: not in windows
MKDIRHIER = 
INSTALL = 
INSTALLFLAGS = 
INSTPGMFLAGS = 
INSTMANFLAGS = 
endif

### There should be no need to edit after this point,
### unless you're using a non-GNU make.


all:: Makefile

Makefile: Makefile.in
	$(RM) $@
	$(CP) $< $@
	make depend

# This variable lists all the auto-generated program files.
AUTOGENS = enc_cmsg.c enc_pmsg.c dec_cmsg.c dec_pmsg.c cmsg_union.h cmsg_size.c pmsg_union.h pmsg_size.c game-enums.c game-enums.h player-enums.c player-enums.h protocol-enums.c protocol-enums.h tiles-enums.c tiles-enums.h fbtiles.c version.h

# This is a trick to make the auto-generated files be created
# by make depend, if they're not already there. Otherwise the
# make depend won't put them in the dependencies.
depend:: $(AUTOGENS)
	echo Remade some auto-generated files

# The programs
PROGRAMS = xmj$(EXE) mj-server$(EXE) mj-player$(EXE)

all:: $(PROGRAMS)

# The controller target. Requires player, tiles, protocol, sysdep

SRCS1 = controller.c player.c tiles.c protocol.c game.c scoring.c sysdep.c
OBJS1 = controller.o player.o tiles.o protocol.o game.o scoring.o sysdep.o

 OBJS = $(OBJS1) $(OBJS2) $(OBJS3)
 SRCS = $(SRCS1) $(SRCS2) $(SRCS3)

mj-server$(EXE): $(OBJS1)
	$(RM) $@
	$(CCLINK) -o $@ $(LDOPTIONS) $(OBJS1)  $(LDLIBS)  $(EXTRA_LOAD_FLAGS)

ifndef Win32

install:: mj-server$(EXE)
	@if [ -d $(DESTDIR)$(BINDIR) ]; then set +x; \
	else (set -x; $(MKDIRHIER) $(DESTDIR)$(BINDIR)); fi
	$(INSTALL) $(INSTALLFLAGS) $(INSTPGMFLAGS)  mj-server$(EXE) $(DESTDIR)$(BINDIR)/mj-server

install.man:: mj-server.man
	@if [ -d $(DESTDIR)$(MANDIR) ]; then set +x; \
	else (set -x; $(MKDIRHIER) $(DESTDIR)$(MANDIR)); fi
	$(INSTALL) $(INSTALLFLAGS) $(INSTMANFLAGS) mj-server.man $(DESTDIR)$(MANDIR)/mj-server.$(MANSUFFIX)

endif # Win32

# the greedy player

SRCS2 = greedy.c client.c player.c tiles.c protocol.c game.c sysdep.c
OBJS2 = greedy.o client.o player.o tiles.o protocol.o game.o sysdep.o

mj-player$(EXE): $(OBJS2) $(DEPLIBS2)
	$(RM) $@
	$(CCLINK) -o $@ $(LDOPTIONS) $(OBJS2)  $(LDLIBS)  $(EXTRA_LOAD_FLAGS)

ifndef Win32

install:: mj-player$(EXE)
	@if [ -d $(DESTDIR)$(BINDIR) ]; then set +x; \
	else (set -x; $(MKDIRHIER) $(DESTDIR)$(BINDIR)); fi
	$(INSTALL) $(INSTALLFLAGS) $(INSTPGMFLAGS)  mj-player$(EXE) $(DESTDIR)$(BINDIR)/mj-player

install.man:: mj-player.man
	@if [ -d $(DESTDIR)$(MANDIR) ]; then set +x; \
	else (set -x; $(MKDIRHIER) $(DESTDIR)$(MANDIR)); fi
	$(INSTALL) $(INSTALLFLAGS) $(INSTMANFLAGS) mj-player.man $(DESTDIR)$(MANDIR)/mj-player.$(MANSUFFIX)

endif # Win32

# the gui

ifdef Win32
# the icon resource file and object
ICONOBJ = iconres.o
iconres.o: iconres.rs icon.ico
	windres iconres.rs iconres.o
else
ICONOBJ =
endif

SRCS3 = gui.c gui-dial.c lazyfixed.c vlazyfixed.c client.c player.c tiles.c fbtiles.c protocol.c game.c sysdep.c
OBJS3 = gui.o gui-dial.o client.o lazyfixed.o vlazyfixed.o player.o tiles.o fbtiles.o protocol.o game.o sysdep.o $(ICONOBJ)

xmj$(EXE): $(OBJS3) $(DEPLIBS3)
	$(RM) $@
	$(CCLINK) -o $@ $(LDOPTIONS) $(OBJS3) $(GUILIBS) $(LDLIBS)  $(EXTRA_LOAD_FLAGS)

install:: xmj$(EXE)
	@if [ -d $(DESTDIR)$(BINDIR) ]; then set +x; \
	else (set -x; $(MKDIRHIER) $(DESTDIR)$(BINDIR)); fi
	$(INSTALL) $(INSTALLFLAGS) $(INSTPGMFLAGS)  xmj$(EXE) $(DESTDIR)$(BINDIR)/xmj

install.man:: xmj.man
	@if [ -d $(DESTDIR)$(MANDIR) ]; then set +x; \
	else (set -x; $(MKDIRHIER) $(DESTDIR)$(MANDIR)); fi
	$(INSTALL) $(INSTALLFLAGS) $(INSTMANFLAGS) xmj.man $(DESTDIR)$(MANDIR)/xmj.$(MANSUFFIX)

# version.h is now made from version.h.in by the release script.
# so if we are not making a release, we'd better provide it if
# it isn't there.
version.h:
	cp version.h.in $@
	chmod u+w $@

# rule to generate the fallback tiles
fbtiles.c: $(FALLBACKTILES) makefallbacktiles Makefile
	$(PERL) makefallbacktiles $(FALLBACKTILES) >fbtiles.c

# Rules for the auto generated files

enc_cmsg.c: protocol.h proto-encode-msg.pl
	$(PERL) proto-encode-msg.pl -cmsg

enc_pmsg.c: protocol.h proto-encode-msg.pl
	$(PERL) proto-encode-msg.pl -pmsg

dec_cmsg.c: protocol.h proto-decode-msg.pl
	$(PERL) proto-decode-msg.pl -cmsg

dec_pmsg.c: protocol.h proto-decode-msg.pl
	$(PERL) proto-decode-msg.pl -pmsg

# rules for the other auxiliary files
# the commands will be executed twice, but never mind.
cmsg_union.h cmsg_size.c: protocol.h proto-encode-msg.pl
	$(PERL) proto-encode-msg.pl -cmsg

pmsg_union.h pmsg_size.c: protocol.h proto-encode-msg.pl
	$(PERL) proto-encode-msg.pl -pmsg

# Rule for the enum parsing files:
%-enums.h: %.h make-enums.pl
	$(PERL) make-enums.pl $<

%-enums.c: %.h make-enums.pl
	$(PERL) make-enums.pl $<

# distclean also removes the auto-generated files and the Makefile
distclean:: clean
	$(RM) Makefile $(AUTOGENS)

# used to build a source release
textdocs:: use.txt rules.txt

use.txt rules.txt: xmj.man
	$(RM) use.txt rules.txt
	$(PERL) maketxt xmj.man
	chmod 444 use.txt rules.txt



depend::
	$(DEPEND) $(DEPENDFLAGS) -- $(ALLDEFINES) $(DEPEND_DEFINES) -- $(SRCS)

clean::
	$(RM) $(PROGRAMS)

clean::
	$(RM) *.o core errs *~
# DO NOT DELETE
controller.o: controller.c controller.h tiles.h player.h player-enums.h \
  protocol.h cmsg_union.h pmsg_union.h protocol-enums.h game.h \
  game-enums.h scoring.h sysdep.h version.h
player.o: player.c player.h tiles.h player-enums.h sysdep.h \
  player-enums.c
tiles.o: tiles.c tiles.h protocol.h player.h player-enums.h cmsg_union.h \
  pmsg_union.h protocol-enums.h sysdep.h
protocol.o: protocol.c protocol.h tiles.h player.h player-enums.h \
  cmsg_union.h pmsg_union.h protocol-enums.h sysdep.h enc_cmsg.c \
  dec_cmsg.c enc_pmsg.c dec_pmsg.c cmsg_size.c pmsg_size.c \
  protocol-enums.c
game.o: game.c game.h tiles.h player.h player-enums.h protocol.h \
  cmsg_union.h pmsg_union.h protocol-enums.h game-enums.h sysdep.h \
  game-enums.c
scoring.o: scoring.c tiles.h player.h player-enums.h controller.h \
  protocol.h cmsg_union.h pmsg_union.h protocol-enums.h game.h \
  game-enums.h scoring.h sysdep.h
sysdep.o: sysdep.c sysdep.h
greedy.o: greedy.c client.h game.h tiles.h player.h player-enums.h \
  protocol.h cmsg_union.h pmsg_union.h protocol-enums.h game-enums.h \
  sysdep.h version.h
client.o: client.c sysdep.h client.h game.h tiles.h player.h \
  player-enums.h protocol.h cmsg_union.h pmsg_union.h protocol-enums.h \
  game-enums.h
player.o: player.c player.h tiles.h player-enums.h sysdep.h \
  player-enums.c
tiles.o: tiles.c tiles.h protocol.h player.h player-enums.h cmsg_union.h \
  pmsg_union.h protocol-enums.h sysdep.h
protocol.o: protocol.c protocol.h tiles.h player.h player-enums.h \
  cmsg_union.h pmsg_union.h protocol-enums.h sysdep.h enc_cmsg.c \
  dec_cmsg.c enc_pmsg.c dec_pmsg.c cmsg_size.c pmsg_size.c \
  protocol-enums.c
game.o: game.c game.h tiles.h player.h player-enums.h protocol.h \
  cmsg_union.h pmsg_union.h protocol-enums.h game-enums.h sysdep.h \
  game-enums.c
sysdep.o: sysdep.c sysdep.h
gui.o: gui.c gui.h lazyfixed.h sysdep.h vlazyfixed.h client.h game.h \

## mah-jong 1.6.3

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.9 2002/01/07 21:45:29 jcb Rel $
+# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.14 2003/10/12 21:10:48 jcb Exp $
 # Master makefile for the xmj suite.
 
 ### NOTE NOTE NOTE
@@ -17,6 +17,10 @@
 all::
 
 ### Local configuration options. Read and edit as necessary.
+
+# This is not available in current public releases.
+# Uncomment the following line to build the table manager.
+# TableManager=1
 
 # The directory in which to find the tile pixmaps that are
 # compiled into the program. Beware of licensing considerations.
@@ -172,8 +176,15 @@
 	$(CP) $< $@
 	make depend
 
+# Autogenerated files to do with the table manager
+ifdef TableManager
+ TMAUTOGENS = enc_mcmsg.c enc_mpmsg.c dec_mcmsg.c dec_mpmsg.c mcmsg_union.h mcmsg_size.c mpmsg_union.h mpmsg_size.c mprotocol-enums.c mprotocol-enums.h
+else
+ TMAUTOGENS = 
+endif
+
 # This variable lists all the auto-generated program files.
-AUTOGENS = enc_cmsg.c enc_pmsg.c dec_cmsg.c dec_pmsg.c cmsg_union.h cmsg_size.c pmsg_union.h pmsg_size.c game-enums.c game-enums.h player-enums.c player-enums.h protocol-enums.c protocol-enums.h tiles-enums.c tiles-enums.h fbtiles.c version.h
+AUTOGENS = enc_cmsg.c enc_pmsg.c dec_cmsg.c dec_pmsg.c cmsg_union.h cmsg_size.c pmsg_union.h pmsg_size.c  game-enums.c game-enums.h player-enums.c player-enums.h protocol-enums.c protocol-enums.h  tiles-enums.c tiles-enums.h fbtiles.c version.h $(TMAUTOGENS)
 
 # This is a trick to make the auto-generated files be created
 # by make depend, if they're not already there. Otherwise the
@@ -182,7 +193,11 @@
 	echo Remade some auto-generated files
 
 # The programs
-PROGRAMS = xmj$(EXE) mj-server$(EXE) mj-player$(EXE)
+ifdef TableManager
+ PROGRAMS = xmj$(EXE) mj-server$(EXE) mj-player$(EXE) mj-manager$(EXE)
+else
+ PROGRAMS = xmj$(EXE) mj-server$(EXE) mj-player$(EXE)
+endif
 
 all:: $(PROGRAMS)
 
@@ -191,8 +206,8 @@
 SRCS1 = controller.c player.c tiles.c protocol.c game.c scoring.c sysdep.c
 OBJS1 = controller.o player.o tiles.o protocol.o game.o scoring.o sysdep.o
 
- OBJS = $(OBJS1) $(OBJS2) $(OBJS3)
- SRCS = $(SRCS1) $(SRCS2) $(SRCS3)
+ OBJS = $(OBJS1) $(OBJS2) $(OBJS3) $(OBJS4)
+ SRCS = $(SRCS1) $(SRCS2) $(SRCS3) $(SRCS4)
 
 mj-server$(EXE): $(OBJS1)
 	$(RM) $@
@@ -211,6 +226,31 @@
 	$(INSTALL) $(INSTALLFLAGS) $(INSTMANFLAGS) mj-server.man $(DESTDIR)$(MANDIR)/mj-server.$(MANSUFFIX)
 
 endif # Win32
+
+ifdef TableManager
+# The table manager. Requires mprotocol and sysdep
+SRCS4 = manager.c mprotocol.c sysdep.c
+OBJS4 = manager.o mprotocol.o sysdep.o
+
+mj-manager$(EXE): $(OBJS4)
+	$(RM) $@
+	$(CCLINK) -o $@ $(LDOPTIONS) $(OBJS4)  $(LDLIBS)  $(EXTRA_LOAD_FLAGS)
+
+ifndef Win32
+
+install:: mj-manager$(EXE)
+	@if [ -d $(DESTDIR)$(BINDIR) ]; then set +x; \
+	else (set -x; $(MKDIRHIER) $(DESTDIR)$(BINDIR)); fi
+	$(INSTALL) $(INSTALLFLAGS) $(INSTPGMFLAGS)  mj-manager$(EXE) $(DESTDIR)$(BINDIR)/mj-manager
+
+install.man:: mj-manager.man
+	@if [ -d $(DESTDIR)$(MANDIR) ]; then set +x; \
+	else (set -x; $(MKDIRHIER) $(DESTDIR)$(MANDIR)); fi
+	$(INSTALL) $(INSTALLFLAGS) $(INSTMANFLAGS) mj-manager.man $(DESTDIR)$(MANDIR)/mj-manager.$(MANSUFFIX)
+
+endif # Win32
+
+endif # TableManager
 
 # the greedy player
 
@@ -296,6 +336,26 @@
 pmsg_union.h pmsg_size.c: protocol.h proto-encode-msg.pl
 	$(PERL) proto-encode-msg.pl -pmsg
 
+enc_mcmsg.c: protocol.h proto-encode-msg.pl
+	$(PERL) proto-encode-msg.pl -mcmsg
+
+enc_mpmsg.c: protocol.h proto-encode-msg.pl
+	$(PERL) proto-encode-msg.pl -mpmsg
+
+dec_mcmsg.c: protocol.h proto-decode-msg.pl
+	$(PERL) proto-decode-msg.pl -mcmsg
+
+dec_mpmsg.c: protocol.h proto-decode-msg.pl
+	$(PERL) proto-decode-msg.pl -mpmsg
+
+# rules for the other auxiliary files
+# the commands will be executed twice, but never mind.
+mcmsg_union.h mcmsg_size.c: protocol.h proto-encode-msg.pl
+	$(PERL) proto-encode-msg.pl -mcmsg
+
+mpmsg_union.h mpmsg_size.c: protocol.h proto-encode-msg.pl
+	$(PERL) proto-encode-msg.pl -mpmsg
+
 # Rule for the enum parsing files:
 %-enums.h: %.h make-enums.pl
 	$(PERL) make-enums.pl $<
@@ -326,40 +386,3 @@
 clean::
 	$(RM) *.o core errs *~
 # DO NOT DELETE
-controller.o: controller.c controller.h tiles.h player.h player-enums.h \
-  protocol.h cmsg_union.h pmsg_union.h protocol-enums.h game.h \
-  game-enums.h scoring.h sysdep.h version.h
-player.o: player.c player.h tiles.h player-enums.h sysdep.h \
-  player-enums.c
-tiles.o: tiles.c tiles.h protocol.h player.h player-enums.h cmsg_union.h \
-  pmsg_union.h protocol-enums.h sysdep.h
-protocol.o: protocol.c protocol.h tiles.h player.h player-enums.h \
-  cmsg_union.h pmsg_union.h protocol-enums.h sysdep.h enc_cmsg.c \
-  dec_cmsg.c enc_pmsg.c dec_pmsg.c cmsg_size.c pmsg_size.c \
-  protocol-enums.c
-game.o: game.c game.h tiles.h player.h player-enums.h protocol.h \
-  cmsg_union.h pmsg_union.h protocol-enums.h game-enums.h sysdep.h \
-  game-enums.c
-scoring.o: scoring.c tiles.h player.h player-enums.h controller.h \
-  protocol.h cmsg_union.h pmsg_union.h protocol-enums.h game.h \
-  game-enums.h scoring.h sysdep.h
-sysdep.o: sysdep.c sysdep.h
-greedy.o: greedy.c client.h game.h tiles.h player.h player-enums.h \
-  protocol.h cmsg_union.h pmsg_union.h protocol-enums.h game-enums.h \
-  sysdep.h version.h
-client.o: client.c sysdep.h client.h game.h tiles.h player.h \
-  player-enums.h protocol.h cmsg_union.h pmsg_union.h protocol-enums.h \
-  game-enums.h
-player.o: player.c player.h tiles.h player-enums.h sysdep.h \
-  player-enums.c
-tiles.o: tiles.c tiles.h protocol.h player.h player-enums.h cmsg_union.h \
-  pmsg_union.h protocol-enums.h sysdep.h
-protocol.o: protocol.c protocol.h tiles.h player.h player-enums.h \
-  cmsg_union.h pmsg_union.h protocol-enums.h sysdep.h enc_cmsg.c \
-  dec_cmsg.c enc_pmsg.c dec_pmsg.c cmsg_size.c pmsg_size.c \
-  protocol-enums.c
-game.o: game.c game.h tiles.h player.h player-enums.h protocol.h \
-  cmsg_union.h pmsg_union.h protocol-enums.h game-enums.h sysdep.h \
-  game-enums.c
-sysdep.o: sysdep.c sysdep.h
-gui.o: gui.c gui.h lazyfixed.h sysdep.h vlazyfixed.h client.h game.h \

## mah-jong 1.7

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.14 2003/10/12 21:10:48 jcb Exp $
+# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.19 2006/01/18 22:48:16 jcb Exp $
 # Master makefile for the xmj suite.
 
 ### NOTE NOTE NOTE
@@ -17,6 +17,14 @@
 all::
 
 ### Local configuration options. Read and edit as necessary.
+
+### DON'T TOUCH THIS! The gtk+2 port is in progress, and does not
+### not work yet.
+# Which gtk+ version do you want?
+# this is for gtk+ 1.2
+# GTK_VERSION undefined  
+# this is for gtk+ 2.0
+# GTK_VERSION = 2.0  
 
 # This is not available in current public releases.
 # Uncomment the following line to build the table manager.
@@ -57,13 +65,16 @@
 CC = gcc
 
 # C debugging and optimization flags. 
-# In development, we turn on all reasonable warnings, thus:
-# CDEBUGFLAGS = -g -Wall -W -Wstrict-prototypes -Wmissing-prototypes
+# In development, we turn on all reasonable warnings.
 # However, in the production releases, we don't because other people's
 # code (e.g. glib) may provoke warnings.
 # Also, we do NOT enable optimization by default, because RedHat 6
 # Linux distributions have a seriously buggy C compiler.
+ifdef Warnings
+CDEBUGFLAGS = -g -Wall -W -Wstrict-prototypes -Wmissing-prototypes
+else
 CDEBUGFLAGS = -g
+endif
 # The -Wconversion flag is also useful to detect (more than usual)
 # abuse of enums, but it generates many superfluous warnings, so
 # is not on by default.
@@ -80,18 +91,22 @@
 DEFINES = -DTILESET='$(TILESET)' -DTILESETPATH='$(TILESETPATH)'
 endif
 
+ifdef GTK_VERSION
+GTKDEFINES = -DGTK2=1 -DGTK_ENABLE_BROKEN
+endif
+
 # Options for compiling.
 ifdef Win32
-# I assume you're using mingw. If you're using cygwin, you also
-# need -fno-cygwin.
-CCOPTIONS = -fnative-struct
+# this is suitable for recent mingw releases (the equivalent
+# of the old -fnative-struct)
+CCOPTIONS = -mms-bitfields
 endif
 
 # Extra libraries needed above whatever the system provides you with.
 # Things like -lnsl on Solaris are the most likely examples.
 ifdef Win32
 # We need the winsock libraries
-LDLIBS = -LC:/winnt/system32 -lwsock32
+LDLIBS =  -lwsock32
 else
 # Red Hat and Mandrake (and probably most other) Linux systems
 # need nothing, as any needed libraries are brought in for gtk anyway.
@@ -102,25 +117,39 @@
 # LDLIBS = -lm
 endif
 
+# some systems have buggy malloc/realloc etc, so we may use
+# Doug Lea's implementation. This is switched on for Windows
+# at the moment
+ifdef Win32
+MALLOCSRC = malloc.c
+MALLOCOBJ = malloc.o
+endif
+
 # The xmj program is built with gtk+, so it needs to know where the
 # libraries and headers are.
 ifdef Win32
-# You'll need to say explicitly where they are, as here:
-EXTRA_INCLUDES=-IC:/gtk/glib -IC:/gtk
+# You'll need to say explicitly where they are, as here, which is
+# a bit of a mess in my setup
+EXTRA_INCLUDES=-IC:/gtk/include/glib-2.0 -IC:/gtk/lib/glib-2.0/include -IC:/gtk/include -IC:/gtk/lib/gtk+/include
 # We also add the flag that makes xmj.exe be a GUI program
-GUILIBS=-LC:/gtk -lgtk-1.3 -lgdk-1.3 -lglib-1.3 -lgmodule-1.3 -Wl,-subsystem,windows
+GUILIBS=-LC:/gtk/lib -lgtk-0 -lgdk-0 -LC:/gtk/bin/ -lglib-2.0-0 -lgmodule-2.0-0 -mwindows
 else
 # Not Windows. If gtk+ is properly installed, this is all that's needed.
+ifdef GTK_VERSION
+EXTRA_INCLUDES=`pkg-config --cflags gtk+-$(GTK_VERSION)`
+GUILIBS=`pkg-config --libs gtk+-$(GTK_VERSION)`
+else
 EXTRA_INCLUDES=`gtk-config --cflags`
 GUILIBS=`gtk-config --libs`
 endif
+endif
 
 # We use gcc to link as well
 CCLINK = $(CC)
 
 # don't mess with these
 ALLINCLUDES = $(INCLUDES) $(EXTRA_INCLUDES)
-ALLDEFINES = $(ALLINCLUDES) $(EXTRA_DEFINES) $(DEFINES)
+ALLDEFINES = $(ALLINCLUDES) $(EXTRA_DEFINES) $(DEFINES) $(GTKDEFINES)
 CFLAGS = $(EXTRA_CFLAGS) $(CDEBUGFLAGS) $(CCOPTIONS) $(ALLDEFINES)
 LDOPTIONS = $(CDEBUGFLAGS) $(CCOPTIONS)  $(EXTRA_LDOPTIONS)
 
@@ -203,8 +232,8 @@
 
 # The controller target. Requires player, tiles, protocol, sysdep
 
-SRCS1 = controller.c player.c tiles.c protocol.c game.c scoring.c sysdep.c
-OBJS1 = controller.o player.o tiles.o protocol.o game.o scoring.o sysdep.o
+SRCS1 = controller.c player.c tiles.c protocol.c game.c scoring.c sysdep.c $(MALLOCSRC)
+OBJS1 = controller.o player.o tiles.o protocol.o game.o scoring.o sysdep.o $(MALLOCOBJ)
 
  OBJS = $(OBJS1) $(OBJS2) $(OBJS3) $(OBJS4)
  SRCS = $(SRCS1) $(SRCS2) $(SRCS3) $(SRCS4)
@@ -229,8 +258,8 @@
 
 ifdef TableManager
 # The table manager. Requires mprotocol and sysdep
-SRCS4 = manager.c mprotocol.c sysdep.c
-OBJS4 = manager.o mprotocol.o sysdep.o
+SRCS4 = manager.c mprotocol.c sysdep.c $(MALLOCSRC)
+OBJS4 = manager.o mprotocol.o sysdep.o $(MALLOCOBJ)
 
 mj-manager$(EXE): $(OBJS4)
 	$(RM) $@
@@ -254,8 +283,8 @@
 
 # the greedy player
 
-SRCS2 = greedy.c client.c player.c tiles.c protocol.c game.c sysdep.c
-OBJS2 = greedy.o client.o player.o tiles.o protocol.o game.o sysdep.o
+SRCS2 = greedy.c client.c player.c tiles.c protocol.c game.c sysdep.c $(MALLOCSRC)
+OBJS2 = greedy.o client.o player.o tiles.o protocol.o game.o sysdep.o $(MALLOCOBJ)
 
 mj-player$(EXE): $(OBJS2) $(DEPLIBS2)
 	$(RM) $@
@@ -286,8 +315,8 @@
 ICONOBJ =
 endif
 
-SRCS3 = gui.c gui-dial.c lazyfixed.c vlazyfixed.c client.c player.c tiles.c fbtiles.c protocol.c game.c sysdep.c
-OBJS3 = gui.o gui-dial.o client.o lazyfixed.o vlazyfixed.o player.o tiles.o fbtiles.o protocol.o game.o sysdep.o $(ICONOBJ)
+SRCS3 = gui.c gui-dial.c lazyfixed.c vlazyfixed.c client.c player.c tiles.c fbtiles.c protocol.c game.c sysdep.c $(MALLOCSRC)
+OBJS3 = gui.o gui-dial.o client.o lazyfixed.o vlazyfixed.o player.o tiles.o fbtiles.o protocol.o game.o sysdep.o $(MALLOCOBJ) $(ICONOBJ)
 
 xmj$(EXE): $(OBJS3) $(DEPLIBS3)
 	$(RM) $@
@@ -349,40 +378,3 @@
 	$(PERL) proto-decode-msg.pl -mpmsg
 
 # rules for the other auxiliary files
-# the commands will be executed twice, but never mind.
-mcmsg_union.h mcmsg_size.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -mcmsg
-
-mpmsg_union.h mpmsg_size.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -mpmsg
-
-# Rule for the enum parsing files:
-%-enums.h: %.h make-enums.pl
-	$(PERL) make-enums.pl $<
-
-%-enums.c: %.h make-enums.pl
-	$(PERL) make-enums.pl $<
-
-# distclean also removes the auto-generated files and the Makefile
-distclean:: clean
-	$(RM) Makefile $(AUTOGENS)
-
-# used to build a source release
-textdocs:: use.txt rules.txt
-
-use.txt rules.txt: xmj.man
-	$(RM) use.txt rules.txt
-	$(PERL) maketxt xmj.man
-	chmod 444 use.txt rules.txt
-
-
-
-depend::
-	$(DEPEND) $(DEPENDFLAGS) -- $(ALLDEFINES) $(DEPEND_DEFINES) -- $(SRCS)
-
-clean::
-	$(RM) $(PROGRAMS)
-
-clean::
-	$(RM) *.o core errs *~
-# DO NOT DELETE

## mah-jong 1.8

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.19 2006/01/18 22:48:16 jcb Exp $
+# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.21 2006/01/26 21:00:13 jcb Exp $
 # Master makefile for the xmj suite.
 
 ### NOTE NOTE NOTE
@@ -284,11 +284,24 @@
 # the greedy player
 
 SRCS2 = greedy.c client.c player.c tiles.c protocol.c game.c sysdep.c $(MALLOCSRC)
+SRCS2A = client.c player.c tiles.c protocol.c game.c sysdep.c $(MALLOCSRC)
 OBJS2 = greedy.o client.o player.o tiles.o protocol.o game.o sysdep.o $(MALLOCOBJ)
+OBJS2A = client.o player.o tiles.o protocol.o game.o sysdep.o $(MALLOCOBJ)
 
 mj-player$(EXE): $(OBJS2) $(DEPLIBS2)
 	$(RM) $@
 	$(CCLINK) -o $@ $(LDOPTIONS) $(OBJS2)  $(LDLIBS)  $(EXTRA_LOAD_FLAGS)
+
+ga: ga.o $(OBJS2A) $(DEPLIBS2)
+	$(RM) $@
+	$(CCLINK) -o $@ $(LDOPTIONS) ga.o $(OBJS2A)  $(LDLIBS)  $(EXTRA_LOAD_FLAGS)
+
+# generic greedy variants
+greedy-%.o: greedy-%.c $(SRCS2A)
+
+greedy-%: greedy-%.o $(OBJS2A)
+	$(RM) $@
+	$(CCLINK) -o $@ $(LDOPTIONS) $< $(OBJS2A)  $(LDLIBS)  $(EXTRA_LOAD_FLAGS)
 
 ifndef Win32
 
@@ -362,19 +375,3 @@
 cmsg_union.h cmsg_size.c: protocol.h proto-encode-msg.pl
 	$(PERL) proto-encode-msg.pl -cmsg
 
-pmsg_union.h pmsg_size.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -pmsg
-
-enc_mcmsg.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -mcmsg
-
-enc_mpmsg.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -mpmsg
-
-dec_mcmsg.c: protocol.h proto-decode-msg.pl
-	$(PERL) proto-decode-msg.pl -mcmsg
-
-dec_mpmsg.c: protocol.h proto-decode-msg.pl
-	$(PERL) proto-decode-msg.pl -mpmsg
-
-# rules for the other auxiliary files

## mah-jong 1.10

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Header: /home/jcb/newmj/RCS/Makefile.in,v 11.21 2006/01/26 21:00:13 jcb Exp $
+# $Header: /home/jcb/MahJong/newmj/RCS/Makefile.in,v 12.1 2009/07/10 07:55:51 jcb Rel $
 # Master makefile for the xmj suite.
 
 ### NOTE NOTE NOTE
@@ -11,6 +11,12 @@
 ### As far as I know, the only other non-portable feature is the
 ### use of %-pattern rules, but they occur in many makes.
 
+# Options can be passed by setting variables from the command line:
+# pass   Gtk=   to build with Gtk+1.2
+# pass   Win32=1  to build with MinGW on Win32 without MSYS
+# pass   Win32=2  to build with MinGW and MSYS
+# pass   Warnings=1  to switch on almost all compiler warnings
+
 # The things you are most likely to change come first!
 
 # first target: don't change!
@@ -18,13 +24,11 @@
 
 ### Local configuration options. Read and edit as necessary.
 
-### DON'T TOUCH THIS! The gtk+2 port is in progress, and does not
-### not work yet.
 # Which gtk+ version do you want?
-# this is for gtk+ 1.2
-# GTK_VERSION undefined  
-# this is for gtk+ 2.0
-# GTK_VERSION = 2.0  
+# If you're using GTK+ 1.2, set Gtk to be empty
+# Gtk =
+# if you're using GTK+ 2.n, for ANY n, set Gtk to be 2.0 .
+Gtk = 2.0
 
 # This is not available in current public releases.
 # Uncomment the following line to build the table manager.
@@ -70,6 +74,9 @@
 # code (e.g. glib) may provoke warnings.
 # Also, we do NOT enable optimization by default, because RedHat 6
 # Linux distributions have a seriously buggy C compiler.
+# I thought the preceding comment should be deleted...but in 2009,
+# SuSE ships with a seriously buggy C compiler (gcc 4.3). So I'll
+# just leave optimization switched off.
 ifdef Warnings
 CDEBUGFLAGS = -g -Wall -W -Wstrict-prototypes -Wmissing-prototypes
 else
@@ -84,15 +91,19 @@
 
 # Defines for the compilation.
 ifdef Win32
+WINDEFINES = -DWIN32=1
+endif
+
+ifeq ($(Win32),2)
 # This doesn't work if one tries to set these. Does anybody know
 # how to get a double quote through DOS or whatever to gcc ?
-DEFINES = -DTILESET=$(TILESET) -DTILESETPATH=$(TILESETPATH) -DWIN32=1
-else
-DEFINES = -DTILESET='$(TILESET)' -DTILESETPATH='$(TILESETPATH)'
-endif
-
-ifdef GTK_VERSION
-GTKDEFINES = -DGTK2=1 -DGTK_ENABLE_BROKEN
+DEFINES = -DTILESET=$(TILESET) -DTILESETPATH=$(TILESETPATH) $(WINDEFINES)
+else
+DEFINES = -DTILESET='$(TILESET)' -DTILESETPATH='$(TILESETPATH)' $(WINDEFINES)
+endif
+
+ifdef Gtk
+GTKDEFINES = -DGTK2=1
 endif
 
 # Options for compiling.
@@ -128,16 +139,23 @@
 # The xmj program is built with gtk+, so it needs to know where the
 # libraries and headers are.
 ifdef Win32
+ifdef Gtk
+# should be the same as unix, if it can find pkg-config
+EXTRA_INCLUDES=$(shell pkg-config --cflags gtk+-$(Gtk))
+# We also add the flag that makes xmj.exe be a GUI program
+GUILIBS=$(shell pkg-config --libs gtk+-$(Gtk)) -mwindows
+else
 # You'll need to say explicitly where they are, as here, which is
 # a bit of a mess in my setup
 EXTRA_INCLUDES=-IC:/gtk/include/glib-2.0 -IC:/gtk/lib/glib-2.0/include -IC:/gtk/include -IC:/gtk/lib/gtk+/include
 # We also add the flag that makes xmj.exe be a GUI program
 GUILIBS=-LC:/gtk/lib -lgtk-0 -lgdk-0 -LC:/gtk/bin/ -lglib-2.0-0 -lgmodule-2.0-0 -mwindows
+endif
 else
 # Not Windows. If gtk+ is properly installed, this is all that's needed.
-ifdef GTK_VERSION
-EXTRA_INCLUDES=`pkg-config --cflags gtk+-$(GTK_VERSION)`
-GUILIBS=`pkg-config --libs gtk+-$(GTK_VERSION)`
+ifdef Gtk
+EXTRA_INCLUDES=`pkg-config --cflags gtk+-$(Gtk)`
+GUILIBS=`pkg-config --libs gtk+-$(Gtk)`
 else
 EXTRA_INCLUDES=`gtk-config --cflags`
 GUILIBS=`gtk-config --libs`
@@ -154,7 +172,7 @@
 LDOPTIONS = $(CDEBUGFLAGS) $(CCOPTIONS)  $(EXTRA_LDOPTIONS)
 
 # various auxiliary program and settings.
-ifndef Win32
+ifeq ($(Win32),)
 # GNU make, we hope
 MAKE = make
 CP = cp -f
@@ -174,11 +192,13 @@
 INSTPGMFLAGS = -s
 INSTMANFLAGS = -m 0444
 else
-# Windows
+ifeq ($(Win32),1)
+# Windows with mingw but not msyste
 # GNU make, we hope
 MAKE = make
 CP = xcopy
-RM = rm /f
+# suppress errors, since del complains if file not there to remove
+RM = -del /f
 # we don't have a makedepend on windows ...
 DEPEND =
 DEPENDFLAGS =
@@ -192,8 +212,26 @@
 INSTALLFLAGS = 
 INSTPGMFLAGS = 
 INSTMANFLAGS = 
-endif
-
+else
+# windows with msys
+MAKE = make
+CP = cp -f
+RM = rm -f
+# we don't have a makedepend on windows ...
+DEPEND =
+DEPENDFLAGS =
+# perl is needed for generating several files
+PERL = perl
+# suffix of executables
+EXE = .exe
+# programs used in installation: not in windows
+MKDIRHIER = 
+INSTALL = 
+INSTALLFLAGS = 
+INSTPGMFLAGS = 
+INSTMANFLAGS = 
+endif
+endif
 ### There should be no need to edit after this point,
 ### unless you're using a non-GNU make.
 
@@ -340,38 +378,3 @@
 	else (set -x; $(MKDIRHIER) $(DESTDIR)$(BINDIR)); fi
 	$(INSTALL) $(INSTALLFLAGS) $(INSTPGMFLAGS)  xmj$(EXE) $(DESTDIR)$(BINDIR)/xmj
 
-install.man:: xmj.man
-	@if [ -d $(DESTDIR)$(MANDIR) ]; then set +x; \
-	else (set -x; $(MKDIRHIER) $(DESTDIR)$(MANDIR)); fi
-	$(INSTALL) $(INSTALLFLAGS) $(INSTMANFLAGS) xmj.man $(DESTDIR)$(MANDIR)/xmj.$(MANSUFFIX)
-
-# version.h is now made from version.h.in by the release script.
-# so if we are not making a release, we'd better provide it if
-# it isn't there.
-version.h:
-	cp version.h.in $@
-	chmod u+w $@
-
-# rule to generate the fallback tiles
-fbtiles.c: $(FALLBACKTILES) makefallbacktiles Makefile
-	$(PERL) makefallbacktiles $(FALLBACKTILES) >fbtiles.c
-
-# Rules for the auto generated files
-
-enc_cmsg.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -cmsg
-
-enc_pmsg.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -pmsg
-
-dec_cmsg.c: protocol.h proto-decode-msg.pl
-	$(PERL) proto-decode-msg.pl -cmsg
-
-dec_pmsg.c: protocol.h proto-decode-msg.pl
-	$(PERL) proto-decode-msg.pl -pmsg
-
-# rules for the other auxiliary files
-# the commands will be executed twice, but never mind.
-cmsg_union.h cmsg_size.c: protocol.h proto-encode-msg.pl
-	$(PERL) proto-encode-msg.pl -cmsg
-

## mah-jong 1.11

=== debian/changelog ===
mah-jong (1.11-2build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:34:00 +0000

mah-jong (1.11-2) unstable; urgency=low

  * Switch to dpkg-source 3.0 (quilt) format.
  * Split the big monolithic patch into several patches managed with
    quilt.
  * debian/control: Add a Homepage field.
  * debian/compat: Switch to debhelper compatibility version 8.
    - debian/control: Update the Build-Depends accordingly.
    - debian/rules: No need to manually remove build-stamp and any more in
      the clean target.
    - debian/rules: Replace the call to "dh_clean -k" (deprecated) with a
      call to dh_prep.

 -- Nicolas Boullis <nboullis@debian.org>  Tue, 03 Jan 2012 00:31:07 +0100

mah-jong (1.11-1) unstable; urgency=low

  * New upstream release.
  * xmj.man: remove an URL that appeared illegitimately in the manpage.
  * Makefile.in, Makefile: Add -lm to GUILIBS to ensure xmj builds
    properly with binutils-gold. Thanks to Peter Fritzsche for pointing
    the problem. (Closes: #555582)
  * debian/rules, Makefile: Exclude the header files for gtk from the
    dependencies hardcoded into the Makefile. This is necessary because
    the path of a few of those header files is now
    architecture-dependant. Thanks to peter green for pointing the problem
    and for suggesting a patch. (Closes: #651585)
  * debian/rules: add targets build-arch and build-indep, as suggested by
    lintian.
  * debian/watch: Update, thanks to Yan Morin. (Closes: #550785)
  * debian/README.Debian: Update the URL for donations to the author.
  * debian/control: Add ${misc:Depends} to the Depends field, as suggested
    by lintian.
  * debian/control: Bump Standards-Version: to 3.9.2.
  * debian/control: Remove the article at the beginning of the description.

 -- Nicolas Boullis <nboullis@debian.org>  Thu, 22 Dec 2011 16:14:56 +0100

mah-jong (1.10-1) unstable; urgency=low

  * The "Thanks Barry for all your work" release.
  * Put the manpages back in section 6.
  * Run debian/rules new-upstream.
  * Make the list of required shared libraries for GTK explicit, and don't
    link with unneeded shared libraries.

 -- Nicolas Boullis <nboullis@debian.org>  Fri, 07 Aug 2009 22:56:54 +0200

mah-jong (1.10-0.1) unstable; urgency=low

  * Non-maintainer upload.
  * New upstream release. (Closes: #523729).
    + Builds with GTK2. (Closes: #515348).
    + Update libgtk1.2-dev build-dep to libgtk2.0-dev.
  * Add .desktop file. (Closes: #493748).
  * Replace pwd with $(CURDIR) in rules.
  * Bump debhelper and compat to 5.
  * Bump Standards Version to 3.8.2. (No changes needed).

 -- Barry deFreese <bdefreese@debian.org>  Tue, 28 Jul 2009 12:44:50 -0400

mah-jong (1.8-1) unstable; urgency=low

  * New upstream release.
  * Don't strip on program installation; rely on dh_strip to strip unless
    requested by the nostrip build option. (Closes: #437549)
  * Don't ignore failures of "make clean", as suggested by lintian.

 -- Nicolas Boullis <nboullis@debian.org>  Wed,  5 Sep 2007 00:55:41 +0200

mah-jong (1.7-2) unstable; urgency=low

  * Don't link with unneeded shared libraries.

 -- Nicolas Boullis <nboullis@debian.org>  Mon, 30 Oct 2006 22:34:02 +0100

mah-jong (1.7-1) unstable; urgency=low

  * The "upstream is working on GTK2 support" release.
  * New upstream release.
  * Switch to the debhelper compatibility version 4.
  * Bump Standards-Version: to 3.7.2.

 -- Nicolas Boullis <nboullis@debian.org>  Mon,  8 May 2006 22:34:58 +0200

mah-jong (1.6.3-2) unstable; urgency=low

  * Remove the old http://www.dcs.ed.ac.uk/home/jcb/MahJong/ URL from
    xmj's manpage since it is not available anymore (and leads to a
    "cannot adjust line" warning by groff).
  * Bump Standards-Version: to 3.6.2.

 -- Nicolas Boullis <nboullis@debian.org>  Sun, 20 Nov 2005 20:29:15 +0100

mah-jong (1.6.3-1) unstable; urgency=low

  * New upstream release.
  * Update changelog entry for 1.6.2-1 (about fixed DOS).

 -- Nicolas Boullis <nboullis@debian.org>  Mon, 24 May 2004 02:13:34 +0200

mah-jong (1.6.2-1) unstable; urgency=low

  * New upstream release.
    - Fix DOS in mj-server by connecting with an empty name.
      (CAN-2004-0458)
  * Add missing quotes around strings in menu item; thanks to lintian for
    reporting the problem.
  * Fix a misplaced test in player.c .

 -- Nicolas Boullis <nboullis@debian.org>  Sat,  8 May 2004 14:49:02 +0200

mah-jong (1.6-1) unstable; urgency=low

  * New upstream release.

 -- Nicolas Boullis <nboullis@debian.org>  Sun, 12 Oct 2003 19:03:27 +0200

mah-jong (1.5.6-2) unstable; urgency=high

  * Urgency set to high because of security issues.
  * Fix remotely exploitable buffer overflows. (CAN-2003-0705)
  * Fix denial of service due to broken handling of escaping. (CAN-2003-0706)
  * Fix handling of escaping.
  * Remove unused and potentially dangerous code in proto-encode-msg.pl
    and proto-decode-msg.pl.
  * Bump Standards-Version: to 3.6.1.

 -- Nicolas Boullis <nboullis@debian.org>  Sun,  7 Sep 2003 22:29:46 +0200

mah-jong (1.5.6-1) unstable; urgency=low

  * New upstream release.
  * Bump Standards-Version: to 3.6.0.

 -- Nicolas Boullis <nboullis@debian.org>  Wed, 16 Jul 2003 18:42:28 +0200

mah-jong (1.5.5-2) unstable; urgency=low

  * Fixed long description thanks to Colin Watson.
  * Bump Standards-Version: to 3.5.10.

 -- Nicolas Boullis <nboullis@debian.org>  Sun, 25 May 2003 02:47:18 +0200

mah-jong (1.5.5-1) unstable; urgency=low

  * New upstream release. (1.5.4 skipped.)
  * Write a new "new-upstream" target for debian/rules to rebuild the
    auto-generated files.

 -- Nicolas Boullis <nboullis@debian.org>  Fri, 11 Apr 2003 22:48:08 +0200

mah-jong (1.5.3-1) unstable; urgency=low

  * The "upstream is really too fast for me" release.
  * New upstream release.
  * Rebuild the auto-generated program files. Because I forgot to do this,
    xmj was complaining about "Unknown option"...


=== debian/control ===
Source: mah-jong
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Nicolas Boullis <nboullis@debian.org>
Build-Depends: debhelper (>= 8.0.0), libgtk2.0-dev
Standards-Version: 3.9.2
Homepage: http://mahjong.julianbradfield.org/

Package: mah-jong
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Original Mah-Jong game
 This is a set of programs to play the original Mah-Jong game: one
 server, one client for a human player and one client for an AI
 player. Hence the game can be played by 1 to 4 human players.
 .
 You should keep in mind that the original Mah-Jong game has nothing
 to do with the well-known solitaire game. (It merely uses the same
 set of tiles.)
 .
 If you like the game, please consider making a donation to the
 (upstream) author. Read /usr/share/doc/mah-jong/README.Debian for
 details.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
CCOPTIONS = "-O0 -Wall"
else
CCOPTIONS = "-O2 -Wall"
endif

new-upstream:
	cp version.h version.h.sav
	make distclean
	mv version.h.sav version.h
	make -f Makefile.in Makefile
	make EXTRA_INCLUDES="`pkg-config --cflags gtk+-2.0 | sed -e 's/-I/-isystem/g'`" depend
	rm Makefile.bak

build: build-arch build-indep
build-indep:
# We have nothing to do.
build-arch: build-stamp
build-stamp:
	dh_testdir
	$(MAKE) CCOPTIONS=$(CCOPTIONS) CDEBUGFLAGS="-g" TILESETPATH=\""/usr/share/mah-jong"\"
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	[ ! -f Makefile ] || $(MAKE) clean
	dh_clean

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	$(MAKE) install DESTDIR=$(CURDIR)/debian/mah-jong/ BINDIR=usr/games INSTPGMFLAGS=
	$(MAKE) install.man DESTDIR=$(CURDIR)/debian/mah-jong/ MANDIR=usr/share/man/man6
	for tileset in fallbacktiles tiles-v1 tiles-numbered tiles-small; do \
	  install -d $(CURDIR)/debian/mah-jong/usr/share/mah-jong/$${tileset}; \
	  install -m 644 $${tileset}/* $(CURDIR)/debian/mah-jong/usr/share/mah-jong/$${tileset}; \
	done


binary-indep:
# We have nothing to do.

binary-arch: build-arch install-arch
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installmenu
	dh_install debian/mah-jong.desktop usr/share/applications
	dh_installchangelogs ChangeLog
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build build-indep build-arch clean binary-indep binary-arch binary install-arch configure

=== debian/watch ===
version=3
http://mahjong.julianbradfield.org/Source/mj-([0-9.]*)-src\.tar\.gz debian uupdate

## mah-jong 1.16

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# $Header: /home/jcb/MahJong/newmj/RCS/Makefile.in,v 12.1 2009/07/10 07:55:51 jcb Rel $
+# $Header: /home/jcb/MahJong/newmj/RCS/Makefile.in,v 12.3 2020/05/26 09:33:53 jcb Exp $
 # Master makefile for the xmj suite.
 
 ### NOTE NOTE NOTE
@@ -15,6 +15,7 @@
 # pass   Gtk=   to build with Gtk+1.2
 # pass   Win32=1  to build with MinGW on Win32 without MSYS
 # pass   Win32=2  to build with MinGW and MSYS
+# pass   Win32=3  to cross-compile on Linux for MinGW
 # pass   Warnings=1  to switch on almost all compiler warnings
 
 # The things you are most likely to change come first!
@@ -57,6 +58,11 @@
 MANDIR = man/man1
 # and the appropriate suffix is 1
 MANSUFFIX = 1
+
+# if you are cross-compiling from Linux to Windows,
+# MGW should be the root of your MinGW hierarchy for the GTK libraries
+MGW=/home/jcb/MinGW
+
 
 ### End of local configuration.
 
@@ -139,6 +145,12 @@
 # The xmj program is built with gtk+, so it needs to know where the
 # libraries and headers are.
 ifdef Win32
+ifeq ($(Win32),3)
+EXTRA_DEFINES=-DXCOMPILE=1
+CC=i686-w64-mingw32-gcc
+EXTRA_INCLUDES=-I$(MGW)/include/glib-2.0 -I$(MGW)/include/gtk-2.0 -I$(MGW)/include/pango-1.0 -I$(MGW)/include/cairo -I$(MGW)/lib/glib-2.0/include -I$(MGW)/lib/gtk-2.0/include -I$(MGW)/include/gdk-pixbuf-2.0 -I$(MGW)/include/atk-1.0
+GUILIBS=-L$(MGW)/lib -lgtk-win32-2.0 -lgdk-win32-2.0 -lgdk_pixbuf-2.0 -lglib-2.0 -lgobject-2.0 -mwindows
+else
 ifdef Gtk
 # should be the same as unix, if it can find pkg-config
 EXTRA_INCLUDES=$(shell pkg-config --cflags gtk+-$(Gtk))
@@ -151,14 +163,16 @@
 # We also add the flag that makes xmj.exe be a GUI program
 GUILIBS=-LC:/gtk/lib -lgtk-0 -lgdk-0 -LC:/gtk/bin/ -lglib-2.0-0 -lgmodule-2.0-0 -mwindows
 endif
+endif
 else
 # Not Windows. If gtk+ is properly installed, this is all that's needed.
+# except that gtk no longer pulls in -lm 
 ifdef Gtk
 EXTRA_INCLUDES=`pkg-config --cflags gtk+-$(Gtk)`
-GUILIBS=`pkg-config --libs gtk+-$(Gtk)`
+GUILIBS=`pkg-config --libs gtk+-$(Gtk)` -lm
 else
 EXTRA_INCLUDES=`gtk-config --cflags`
-GUILIBS=`gtk-config --libs`
+GUILIBS=`gtk-config --libs` -lm
 endif
 endif
 
@@ -358,23 +372,6 @@
 # the gui
 
 ifdef Win32
-# the icon resource file and object
-ICONOBJ = iconres.o
-iconres.o: iconres.rs icon.ico
-	windres iconres.rs iconres.o
-else
-ICONOBJ =
-endif
-
-SRCS3 = gui.c gui-dial.c lazyfixed.c vlazyfixed.c client.c player.c tiles.c fbtiles.c protocol.c game.c sysdep.c $(MALLOCSRC)
-OBJS3 = gui.o gui-dial.o client.o lazyfixed.o vlazyfixed.o player.o tiles.o fbtiles.o protocol.o game.o sysdep.o $(MALLOCOBJ) $(ICONOBJ)
-
-xmj$(EXE): $(OBJS3) $(DEPLIBS3)
-	$(RM) $@
-	$(CCLINK) -o $@ $(LDOPTIONS) $(OBJS3) $(GUILIBS) $(LDLIBS)  $(EXTRA_LOAD_FLAGS)
-
-install:: xmj$(EXE)
-	@if [ -d $(DESTDIR)$(BINDIR) ]; then set +x; \
-	else (set -x; $(MKDIRHIER) $(DESTDIR)$(BINDIR)); fi
-	$(INSTALL) $(INSTALLFLAGS) $(INSTPGMFLAGS)  xmj$(EXE) $(DESTDIR)$(BINDIR)/xmj
-
+ifeq ($(Win32),3)
+WR = i686-w64-mingw32-windres
+else

=== debian/changelog ===
mah-jong (1.16-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:53:04 +1100

mah-jong (1.16-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 05:39:15 +0000

mah-jong (1.16-1) unstable; urgency=medium

  * New Maintainer: xiao sheng wen (Closes: #1050172)
  * New upstream version (Closes: #815329)
  * routine-update
    - Standards-Version: 4.6.2
    - debhelper-compat 13
    - Rules-Requires-Root: no
    - Trim trailing whitespace.
    - Use secure URI in Homepage field.
    - watch file standard 4
  * debian/patches
    - update manpages_section_6 and add Forwarded: not-needed
    - add cross.patch: Make pkg-config substitutable,
      Fix FTCBFS: (Closes: #901469)
    - add Makefile.in.Hardening.patch
    - add gui.c-fix-typo.patch
    - refresh for new upstream version
  * add d/clean for clean debian/mah-jongbin/
  * add d/install
  * add d/u/metadata
  * add d/lintian-overrides
  * add d/mah-jong.xpm icon (Closes: #737970)
  * d/mah-jong.desktop: add Keywords
  * d/README.Debian: update to use upstream homepage as donation url
  * d/control: add Vcs-Browser Vcs-Git url
  * d/copyright: update format to Machine-readable dep5
  * d/rules: update to debhelper-compat 13
  * d/watch: fix debian-watch-uses-insecure-uri
  * remove d/menu, useless
  * Run wrap-and-sort -asbkt

 -- xiao sheng wen <atzlinux@sina.com>  Tue, 12 Sep 2023 21:41:15 +0800

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,22 @@
 Section: games
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Nicolas Boullis <nboullis@debian.org>
-Build-Depends: debhelper (>= 8.0.0), libgtk2.0-dev
-Standards-Version: 3.9.2
-Homepage: http://mahjong.julianbradfield.org/
+XSBC-Original-Maintainer: xiao sheng wen <atzlinux@sina.com>
+Build-Depends:
+ debhelper-compat (= 13),
+ libgtk2.0-dev,
+ pkgconf,
+Standards-Version: 4.6.2
+Homepage: https://mahjong.julianbradfield.org/
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/atzlinux-guest/mah-jong
+Vcs-Git: https://salsa.debian.org/atzlinux-guest/mah-jong.git
 
 Package: mah-jong
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: Original Mah-Jong game
  This is a set of programs to play the original Mah-Jong game: one
  server, one client for a human player and one client for an AI

=== debian/watch ===
version=4
https://mahjong.julianbradfield.org/Source/mj-([0-9.]*)-src\.tar\.gz debian uupdate
